#include "../src/stm/wlpdstm.h"

#ifdef USE_LONG_JUMP

#define BEGIN_TRANSACTION             \
	if(sigsetjmp(*wlpdstm::get_long_jmp_buf(), 0) != LONG_JMP_ABORT_FLAG) {   \
        wlpdstm::start_tx()

#define BEGIN_TRANSACTION_ID(TX_ID)   \
    if(sigsetjmp(*wlpdstm::get_long_jmp_buf(), 0) != LONG_JMP_ABORT_FLAG) {   \
		wlpdstm::start_tx(TX_ID)

#define END_TRANSACTION					\
		wlpdstm::commit_tx();			\
	}

#define BEGIN_TRANSACTION_DESC			\
	if(sigsetjmp(*wlpdstm::get_long_jmp_buf(tx), 0) != LONG_JMP_ABORT_FLAG) {	\
		wlpdstm::start_tx(tx)

#define BEGIN_TRANSACTION_DESC_ID(TX_ID)	\
	if(sigsetjmp(*wlpdstm::get_long_jmp_buf(tx), 0) != LONG_JMP_ABORT_FLAG) {	\
		wlpdstm::start_tx(TX_ID)

#define END_TRANSACTION_DESC				\
		wlpdstm::commit_tx(tx);				\
	}

#else

//////////////////
// start/end tx //
//////////////////

#define BEGIN_TRANSACTION           \
	while(true) {                   \
		try {                       \
			wlpdstm::start_tx()

#define BEGIN_TRANSACTION_ID(TX_ID) \
    while(true) {                   \
        try {                       \
            wlpdstm::start_tx(TX_ID)


// body goes in the middle

#define END_TRANSACTION                         \
			wlpdstm::commit_tx();               \
			break;                              \
		} catch (wlpdstm::RestartedException) { \
			/* do nothing */                    \
        } catch (wlpdstm::AbortedException) {   \
            throw;                              \
        }                                       \
    }


////////////////////////////////////////////
// start/end transaction and count aborts //
////////////////////////////////////////////

#define BEGIN_TRANSACTION_CA        \
	while(true) {                   \
		try {                       \
			wlpdstm::start_tx()

// body goes in the middle

#define END_TRANSACTION_CA                      \
			wlpdstm::commit_tx();               \
			break;                              \
		} catch (wlpdstm::RestartedException) { \
			aborts++;                           \
        } catch (wlpdstm::AbortedException) {   \
        	aborts++;                           \
            throw;                              \
        }                                       \
    }

#endif /* USE_LONG_JUMP */
