/**
 * Mask differences related to long_jmp functions on different platform.
 *
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 *
 */

#ifndef WLPDSTM_JMP_H_
#define WLPDSTM_JMP_H_

#ifdef USE_LONG_JUMP
#include <setjmp.h>

#ifdef MACOS
#define LONG_JMP_BUF sigjmp_buf
#elif defined LINUXOS
#define LONG_JMP_BUF jmp_buf
#endif /* MACOS */

#define LONG_JMP_FIRST_FLAG 0
#define LONG_JMP_RESTART_FLAG 1
#define LONG_JMP_ABORT_FLAG 2

#endif /* USE_LONG_JUMP */

#endif /* WLPDSTM_JMP_H_ */

