/**
 *  @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 *
 */

#ifndef WLPDSTM_TIMING_H_
#define WLPDSTM_TIMING_H_

#include <stdint.h>

inline uint64_t get_clock_count() {
	uint64_t ret;
	__asm__ volatile ("rdtsc" : "=A" (ret));
	return ret;
}

inline void wait_cycles(uint64_t cycles) {
	uint64_t start = get_clock_count();
	uint64_t end;

	while(true) {
		end = get_clock_count();

		if(end - start > cycles) {
			break;
		}
	}
}

#endif /* WLPDSTM_TIMING_H_ */

