#ifndef WLPDSTM_VERSION_LOCK_H_
#define WLPDSTM_VERSION_LOCK_H_

#include "../constants.h"

namespace wlpdstm {

	typedef void *VersionLock;
	//typedef unsigned VersionLock;

	inline bool is_locked(VersionLock lock) {
		return (unsigned)lock & LSB;
	}

	inline bool is_read_locked(VersionLock lock) {
		return (unsigned)lock & LSB;
	}

	inline bool is_write_locked(VersionLock lock) {
		return lock != WRITE_LOCK_CLEAR;
	}	

	inline unsigned get_value(VersionLock lock) {
		return (unsigned)lock >> LOCK_RESERVED_BITS;
	}

	inline VersionLock get_version_lock(unsigned ts) {
		return (VersionLock)(ts << LOCK_RESERVED_BITS);
	}

	inline VersionLock get_locked(void *thread) {
		return (VersionLock)((unsigned)thread | LSB);
	}

	inline void *get_ptr(VersionLock lock) {
		return (void *)((unsigned)lock & ~LSB);
	}
}

#endif // WLPDSTM_VERSION_LOCK_H_
