/**
 * @file tid.h
 * 
 * Declaration of elements required for thread identifier management
 * are in this file.
 * 
 * @author Aleksandar Dragojevic aleksandar.dragojevic@epfl.ch
 */

#ifndef WLPDSTM_TID_H_
#define WLPDSTM_TID_H_

#include <pthread.h>

namespace wlpdstm {
	void init_tid_generator();

	void init_thread_tid();

	unsigned get_tid();

	unsigned get_thread_count();

	extern ::pthread_key_t tid_key;
}

inline unsigned wlpdstm::get_tid() {
	return (unsigned)::pthread_getspecific(tid_key);
}

#endif
